//----------------------------BEGIN LICENSE----------------------------
/* 
 * Willow : the Open Source WorkFlow Project
 * Distributable under GNU LGPL license by gun.org
 *
 * Copyright (C) 2004-2010 huihoo.org 
 * Copyright (C) 2004-2010  ZosaTapo <dertyang@hotmail.com> 
 * 
 * ====================================================================
 * Project Homepage : http://www.huihoo.org/willow
 * Source Forge     : http://sourceforge.net/projects/huihoo
 * Mailing list     : willow@lists.sourceforge.net 
 */
//----------------------------END  LICENSE-----------------------------
package org.huihoo.workflow.xpdl;

import java.util.List;

import org.huihoo.workflow.*;
import org.huihoo.workflow.xpdl.parameter.FormalParameter;

public abstract class WorkflowApplication extends WorkflowComplexComponent implements WorkflowXPDLComponent
{  
	/** 
	 * Construct a new WorkflowComponenet.
	 */
	protected WorkflowApplication()
	{
		this(null, null);
	}
	
	/** 
	 * Construct a new WorkflowComponenet.
	 *
	 * @param uuid_ The element ID
	 * @param name The element name
	 */
	protected WorkflowApplication(String uuid, String name)
	{
		this(uuid, name, null);
	}
	
	/** 
	 * Construct a new WorkflowComponenet.
	 *
	 * @param uuid_       The element ID
	 * @param name        The element name
	 * @param description The element description
	 */
	protected WorkflowApplication(String uuid_, String name, String description)
	{
		super(uuid_, name, description);
	}
	
  /** 
   * Return a List of all FormalParameters for the application.  
   * @return A List of FormalParameter objects
   */ 
   public abstract List getFormalParameters();
   
	 public abstract void addFormalParameter(FormalParameter formalParameter);

   public abstract FormalParameter findFormalParameter(String ID);
	 public abstract FormalParameter findFormalParameter(int index);

	 public abstract FormalParameter removeFormalParameter(FormalParameter fp);	 
	 
   public abstract String getQualifiedClassName();
	 public abstract void  setQualifiedClassName(String className);
}
